'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HistoryStub = exports.WindowStub = undefined;

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var WINDOW_UID = 'window';

var WindowStub = exports.WindowStub = function WindowStub() {
  var initialPath = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '/';
  (0, _classCallCheck3.default)(this, WindowStub);

  this.location = {
    href: 'http://address/' + initialPath,
    pathname: initialPath,
    search: ''
  };

  this.document = {
    referrer: 'http://referrer1',

    querySelector: function querySelector() {
      return true;
    }
  };
};

var HistoryStub = exports.HistoryStub = function HistoryStub() {
  var _this = this;

  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [{ data: {}, title: null, hash: 'url' }];
  (0, _classCallCheck3.default)(this, HistoryStub);

  this.getState = function () {
    return _this.state[_this.position];
  };

  this.replaceState = function (data, title, href) {
    var _state$position = _this.state[_this.position],
        currentData = _state$position.data,
        currentTitle = _state$position.title,
        currentUrl = _state$position.hash;


    var newState = {
      data: data || currentData,
      title: title || currentTitle,
      hash: href || currentUrl
    };

    _this.state = [].concat((0, _toConsumableArray3.default)(_this.state.slice(0, _this.position)), [newState]);

    _this.Adapter.trigger(null, 'statechange');
  };

  this.pushState = function (data, title, href) {
    var _state$position2 = _this.state[_this.position],
        currentData = _state$position2.data,
        currentTitle = _state$position2.title,
        currentUrl = _state$position2.hash;


    var newState = {
      data: data || currentData,
      title: title || currentTitle,
      hash: href || currentUrl
    };

    _this.state = [].concat((0, _toConsumableArray3.default)(_this.state.slice(0, _this.position + 1)), [newState]);

    _this.position = _this.position + 1;
    _this.Adapter.trigger(null, 'statechange');
  };

  this.Adapter = {
    handlers: (0, _defineProperty3.default)({}, WINDOW_UID, {}),

    uid: function uid() {
      return WINDOW_UID;
    },

    bind: function bind(scope, event, callback) {
      var handler = _this.Adapter.handlers[WINDOW_UID];

      (0, _assign2.default)(handler, (0, _defineProperty3.default)({}, event, [].concat((0, _toConsumableArray3.default)(handler[event] || []), [callback])));
    },

    trigger: function trigger(scope, event, data) {
      (_this.Adapter.handlers[WINDOW_UID][event] || []).forEach(function (callback) {
        return callback(data);
      });
    }
  };

  this.back = function () {
    _this.position = _this.position - 1;
    _this.Adapter.trigger(null, 'statechange');
  };

  this.forward = function () {
    if (_this.state[_this.position + 1]) {
      _this.position = _this.position + 1;
      _this.Adapter.trigger(null, 'statechange');
    }
  };

  this.position = state.length === 0 ? 0 : state.length - 1;
  this.state = [].concat((0, _toConsumableArray3.default)(state));
};